/*
 *Copyright (c) 2008, Scendix Software, Inc.
 * 
 */
using System;
using System.IO; 
using System.Reflection;
using Microsoft.Win32;
using Microsoft.MediaCenter.UI;


namespace mceTapiRexv2.Utils
{
	/// <summary>Zusammenfassung fr Class1.</summary>
	public class ToolsLib
	{
		public ToolsLib()
		{
		}

		public static string LogFileName
		{
            get {
                return RegistryUtil.ReadFromRegistry(Registry.LocalMachine, "SOFTWARE\\Scendix\\TapiRex", "InstallDir", Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetName().CodeBase).Replace("file:\\", "") + "\\") + "protocol.log"; 
            }
		}

		public static bool WriteLog
		{
            get { 
                return isTrue(RegistryUtil.ReadFromRegistry(Registry.LocalMachine, "SOFTWARE\\Scendix\\TapiRex", "Log", "false")); 
            }
		}

		public static bool isTrue(object o) 
		{
			if(o == null)
				return false;
			if(o.ToString() == "0")
				return false;
			if(o.ToString().ToLower() == "false")
				return false;
			if(o.ToString().ToLower() == "falsch")
				return false;
			return true;
		}

		public static int Val(object o)
		{
			try 
			{
				return Int32.Parse(o.ToString());
			} 
			catch
			{
			}
			return 0;
		}


		public static void LogStr(string sLogText)
		{
			if(WriteLog)
			{
				try
				{
					StreamWriter sw = new StreamWriter(LogFileName, true);
					sw.WriteLine(System.DateTime.Now + " " + sLogText);
					sw.Close();
				} 
				catch
				{
					//System.Windows.Forms.MessageBox.Show("Error writing to LOG");
				}
			}
		}
		
		private static string Format00(int iIn)
		{
			if(iIn < 10)
				return "0" + iIn.ToString();
			return iIn.ToString();
		}

		public static string PackDate(DateTime tim)
		{
			return tim.Year.ToString() + Format00(tim.Month) + Format00(tim.Day);
		}
		public static DateTime UnpackDate(string sIn)
		{
			return new DateTime(Val(sIn.Substring(0, 4)), Val(sIn.Substring(4, 2)), Val(sIn.Substring(6, 2)));
		}
	}
}
